/***************************************************************************
                          ann_ds_rec.h  -  description
                             -------------------
    begin                : pon kwi 14 2003
    copyright            : (C) 2003 by Bartosz Lis
    email                : bartoszl@ics.p.lodz.pl
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __ANN_DS_REC_H
#define __ANN_DS_REC_H

#include <ctype.h>

#include <ann_loc.h>
#include <ann_ds.h>

namespace ANN
{

  class DS_rec; /* recurent data source */

  //              //
 // class DS_rec //
//              //

  class DS_rec : public virtual DS
  {
  private:
    DS_rec();

  protected:
    DS *orig;

    DS_rec(DS &orig_) : orig(&orig_) {}

  public:
    virtual ~DS_rec();

    virtual const Size &get_lengths() const;
    virtual size_t      get_length() const;
    virtual const Size &get_sizes() const;
    virtual size_t      get_size() const;
    virtual Term       &term();
    virtual const Term &term() const;
    virtual bool        reset();
    virtual void        feed();
    virtual bool        seek(size_t term_pos_);
    virtual bool        locate(const Loc &loc);
    virtual const Loc  &where() const;
    virtual size_t      which() const;
  };

} // namespace ANN

#endif /* __ANN_DS_REC_H */
